

/*****************************************************************************

ScrumPy -- Metabolic Modelling with Python

Copyright Mark Poolman 1995 - 2002

 This file is part of ScrumPy.

    ScrumPy is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    ScrumPy is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ScrumPy; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


*****************************************************************************/
/***

M.G. Poolman 8/11/99 onwards
VarTbl.h  -- simple variable table of pointers to double
Version for ScrumPy, not that different from the Scrumpi 
ModVarTbl class 

***/

#ifndef VarTbl_H
#define VarTbl_H 1

#include <BSTree.h>
#include <ScampiModelBase.h>

class VarTbl : public BSTree {

  public:
 
	VarTbl() {;} ; 
	~VarTbl() {;} ;

	double *Search(const char *Name) ;
	  /* pre: true
	    post: (Search(Name) == 0) => Name not present
			  ELSE Search(Name) == pointer to value of Name */
	
	Component_id GetId(const char *Name) ;
	  /* pre: (Search(Name) != 0)
	    post: GetId(Name) == component id of name */
	
	void Add(const char *Name, double *val, Component_id comp) ;
	  /* pre: Search(Name) == 0 ;
	    post: Search(Name) == val */
} ; 

		
#endif
