

/*****************************************************************************

ScrumPy -- Metabolic Modelling with Python

Copyright Mark Poolman 1995 - 2002

 This file is part of ScrumPy.

    ScrumPy is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    ScrumPy is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ScrumPy; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

******************************************************************************/
/***
  M.G.Poolman 20/7/00
  fute.h - misc. file utils
***/


#include "fute.h"

#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>
#include <time.h>

bool IsReadable(const char *fname){

	FILE *fp ;
	bool rv = false ;
	
	if(fp = fopen(fname, "r")){
		rv = true ;
		fclose(fp) ;
	}
	return(rv) ;
} ;


bool IsNewer(const char *fileA, const char *fileB){
	
  struct stat statA, statB ;
  
	stat(fileA, &statA) ;
	stat(fileB, &statB) ;

	return(difftime(statA.st_mtime, statB.st_mtime) > 0.0) ;
} ;	



extern int CountChars(const char *fname, const char targ) {
	/* pre: true
	  post: n = CountChars(f,t) >= 0 => n is number of instances of t in f before EOF
	  	    n < 0 => couldn't open f for reading */  

  FILE *fp ; 
  char c ; 
  int rv = -1 ;
  
  	if(fp = fopen(fname, "r")){
		rv++ ;
		while((c = getc(fp)) != EOF){
			if (c == targ)
				rv++ ;
		}
		fclose(fp) ;
	}
	return rv ;
}
























