

/*****************************************************************************

ScrumPy -- Metabolic Modelling with Python

Copyright Mark Poolman 1995 - 2002

 This file is part of ScrumPy.

    ScrumPy is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    ScrumPy is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ScrumPy; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


*****************************************************************************/
/*
	M.G.Poolman 5/8/99
	Tree - General purpose oo binary search tree 
*/


#ifndef BSTREE_H
#define BSTREE_H

#include<iostream>
#include"Node.h"

typedef void (*TravFunc_t)(NodeUsrDat *NodDat, void *UsrDat) ;
  
class BSTree{
	
  public:
  
	BSTree() ;
	
	~BSTree() ;
		
	NodeUsrDat *Search(const char *key) ;
  
 	void Add(NodeUsrDat *dat) ;
	
	void Remove(const char *key) ;
		
	void Print(ostream &out) ;
	
	void Clear(void) ;

	void TraverseDoing(TravFunc_t UsrTravFunc, void *UsrDat) ;
	   
  private:
  
  	NodeUsrDat *Search(const char *key, Node *here) ; 
	
	Node **SearchParentP(const char *key) ;
	
	Node **SearchParentP(const char *key, Node *start) ;
	
	Node *FindParLeftMost(Node *n) ;

	Node *RemoveLeftMostFromRight(Node *n) ;
	
	void Add(NodeUsrDat *dat, Node *here) ;
				
	void Print(ostream &out, Node *here, int recdepth) ;
	
	void TraverseDoing(Node *here, TravFunc_t UsrTravFunc, void *UsrDat) ;
	
	Node *TopNode, ParentOfTop ;
} ;
		

#endif






		
