

/*****************************************************************************

ScrumPy -- Metabolic Modelling with Python

Copyright Mark Poolman 1995 - 2002

 This file is part of ScrumPy.

    ScrumPy is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    ScrumPy is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ScrumPy; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


*****************************************************************************/
/*
	M.G.Poolman Aug 99
	Node.h
	G.P. nodes for dynamic c++ structures
*/



#ifndef NODE_H
#define NODE_H


#include<iostream.h>

class NodeUsrDat{

	public:

		NodeUsrDat() ;
		
		NodeUsrDat (NodeUsrDat &src) ;
		
		~NodeUsrDat();
		
		void operator=(NodeUsrDat &src) ;
		
		virtual char *GetKey(void) ;
		
		/* compare > 0 => str > this */ 
		virtual int Compare(const char *str) ;
						
		virtual void Print(ostream &out);
} ;



class Node{

	public:

		Node() ;
	
		Node(NodeUsrDat *dat) ;
	
		~Node() ;

		void Print(ostream &out) ;
	
		Node *Right, *Left ;
	
		NodeUsrDat *Usr ;
	
		void Infanticide(void) ;
	
} ;

#endif

  
