

/*****************************************************************************

ScrumPy -- Metabolic Modelling with Python

Copyright Mark Poolman 1995 - 2002

 This file is part of ScrumPy.

    ScrumPy is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    ScrumPy is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ScrumPy; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


*****************************************************************************/

#ifndef SS_SCRATCHPAD_H
#define SS_SCRATCHPAD_H 1


#include "ScampiConsts.h"


#ifdef __cplusplus
#define extern extern "C"
#endif


typedef struct SS_ScratchPad *SS_ScratchPad_t ;

extern SS_ScratchPad_t NewSS_ScratchPad(int n_Free, double *InitMets, double *InitODEs, SSFunc_t func) ;

extern void DelSS_ScratchPad(SS_ScratchPad_t sp) ;



extern double Solve (SS_ScratchPad_t sp,  int Max_Iters, double tol, 
						enum SPI_err *err) ;

#ifdef __cplusplus
#undef extern
#endif

#endif
