

/*****************************************************************************

ScrumPy -- Metabolic Modelling with Python

Copyright Mark Poolman 1995 - 2002

 This file is part of ScrumPy.

    ScrumPy is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    ScrumPy is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ScrumPy; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


*****************************************************************************/

#ifndef SCAMPI_CONSTS_H
#define SCAMPI_CONSTS_H 1

#ifndef TRUE
#define FALSE 0
#define TRUE !FALSE
#endif


typedef  void (*func_pt)(int, double, double *, double *, double *) ;
/* this to go shortly */


typedef void(*EvalFunc_pt)(int, double *, double *, int *) ;


typedef void (*SSFunc_t)(long int *, double *, double *, int *) ;
/* function for ss solvers -
func(n_Free, MetValues, ODEValues, ErrorFlag)
n_Free ignored, ODEValues uppdated from MetValues, 
ErrorFlag ignored
*/


typedef void (*IntegFunc_t) (long int *, double *, double *, double *) ;
/* function for integrators -
func(n_Free, Time, MetValues, ODEValues, ErrorFlag)
As SSFunc, but will calculate any time dep funcs at Time, 
model time not altered on return
*/




enum Component_id {Time, Param, Conc, Vel, dMet} ;

enum SPI_err{ OK, NegConc, OutOfTol, SingMat, IntegError, 
		NoMem, BadFile, NoDat, Undefined } ;

#ifdef WANT_SPI_ERR_MSG

char *SPI_errMsgs[] = { 
	"No Error", 
	"Negative concentration", 
	"Requested tolerance not achieved",
	"Solver can't get steady state with these start conditions",
	"Simulation can't proceed from this position",
	"Out of memory",
	"Couldn't open file",
	"No more data",
	"Model not defined" } ;

#else

extern char *SPI_errMsgs[] ;

#endif

#define NameLength 40



#endif
