

/*****************************************************************************

ScrumPy -- Metabolic Modelling with Python

Copyright Mark Poolman 1995 - 2002

 This file is part of ScrumPy.

    ScrumPy is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    ScrumPy is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ScrumPy; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


*****************************************************************************/
/*
	M.G.Poolman 5/8/99
	Tree - General purpose oo binary search tree 
*/

#include<iostream>
#include"Node.h"

class NodeUsrDat{

	public:

		NodeUsrDat();
		
		NodeUsrDat (NodeUsrDat &src) ;
		
		~NodeUsrDat() ;
		
		void operator=(NodeUsrDat &src) ;
		
		virtual char *GetKey(void) ;
		
		/* compare > 0 => str > this */ 
		virtual int Compare(char *str);
				
		virtual void Print(ostream &out) ;
} ;

  
class BSTree{
	
  public:
  
	BSTree() ;
	
	NodeUsrDat *Search(char *key) ;
  
 	void Add(NodeUsrDat *dat) ;
	
	void Remove(char *key) ;
		
	void Print(ostream &out) ;
   
  private:
  
  	NodeUsrDat *Search(char *key, Node *here) ; 
	
	Node **SearchParentP(char *key) ;
	
	Node **SearchParentP(char *key, Node *start) ;
	
	Node *FindParLeftMost(Node *n) ;

	Node *RemoveLeftMostFromRight(Node *n) ;
	
	void Add(NodeUsrDat *dat, Node *here) ;
				
	Print(ostream &out, Node *here, int recdepth) ;
	
	Node *TopNode, ParentOfTop ;
} ;
		






int main(){
	
	BSTree bt ;
	Node *p,  **pp ;
	
	char *strings[]= {
		"m", "k", "q", "a", "z", "l", "o", "zebra", "bison", "gnu", 
		"whale", "mudshark", "yacc", "gnat" } ;
	int n ;
	
	
	
	for (n = 0 ; n < 14 ; n++)
		bt.Add(new MyDat (strings[n])) ;

	bt.Print(cerr) ;

	for (n = 7 ; n >= 0 ; n--){
		bt.Remove(strings[n]) ;
		bt.Print(cerr) ;
	}


	for (n = 13 ; n >= 7 ; n--){
		bt.Remove(strings[n]) ;
		bt.Print(cerr) ;
	}
	
	
	return(0) ;

}







		
