/*
	M.G.Poolman 5/8/99
	Tree - General purpose oo binary search tree 
*/

#include<strings.h>
#include"BSTree.h"

#include <HandyMacros.h> 

  

BSTree::BSTree(){
 
	ParentOfTop.Left = ParentOfTop.Right = TopNode = 0 ;  
} ;


BSTree::~BSTree(){

	ParentOfTop.Infanticide()  ;
} ;



void BSTree::Clear(void){
	ParentOfTop.Infanticide()  ;
	ParentOfTop.Left = ParentOfTop.Right = TopNode = 0 ; 
} ;

	

	
void BSTree::TraverseDoing(Node *here, TravFunc_t UsrTravFunc, void *UsrDat) {
	
	if(here){
		TraverseDoing(here->Right, UsrTravFunc, UsrDat) ;
		UsrTravFunc(here->Usr, UsrDat)  ;
		TraverseDoing(here->Left, UsrTravFunc, UsrDat) ;
	}
} ;
	
	

void BSTree::TraverseDoing(TravFunc_t UsrTravFunc, void *UsrDat) {
	
	TraverseDoing(TopNode, UsrTravFunc, UsrDat) ;
}	
	   





NodeUsrDat * BSTree::Search(const char *key){

	return (Search(key, TopNode)) ; 
} ; 
  
void BSTree::Add(NodeUsrDat *dat){
	if(TopNode == 0){
		TopNode = new Node (dat);
		ParentOfTop.Right = TopNode ;
	}
	else
		Add(dat, TopNode) ;
}



	
Node * BSTree::FindParLeftMost(Node *n){
		
	if(n->Left->Left)
		return(FindParLeftMost(n->Left)) ;
	return(n) ;
} ;


Node * BSTree::RemoveLeftMostFromRight(Node *n) {

	Node *Leftmost, *ParLeftmost  ;
	
	if(n->Right->Left){
		ParLeftmost = FindParLeftMost(n->Right) ;
		Leftmost = ParLeftmost->Left ;
		ParLeftmost->Left = Leftmost->Right ;
		
	}
	else{
		ParLeftmost = n ;
		Leftmost = ParLeftmost->Right ;
		ParLeftmost->Right = Leftmost->Right ;
		
	}
	
	Leftmost->Right = 0 ; 
	Leftmost->Left = 0 ; 
	return(Leftmost) ;
} ;
	




Node **BSTree::SearchParentP(const char *key){
		
	if(TopNode != 0)
		return(SearchParentP(key, &ParentOfTop)) ;
	return(0) ;
} ;
		
	
Node **BSTree::SearchParentP(const char *key, Node *start){
	  
  int cmp ;
  Node **res = 0, *n ;
	  
	if(start->Right != 0){
	  	cmp = start->Right->Usr->Compare(key) ;
		if (cmp == 0) 
			res = &(start->Right) ;
		else
			res = SearchParentP(key, start->Right) ;
	}
		
	if((res == 0) && (start->Left != 0)){
		cmp =  start->Left->Usr->Compare(key) ;
		if(cmp == 0)
			res = &(start->Left) ;
		else
			res = SearchParentP(key, start->Left) ;
	}
		
	return(res) ;
}
		


	
void BSTree::Remove(const char *key) {
	
	Node *targ, *tmp, **targp ;
	// enum children {none, left, right, both} n_ch = none ;
	
	const int none = 0, left = 1, right = 2, both = 3 ;
	int n_ch = none ;
	
	if(targp = SearchParentP(key)){
		targ = *targp ;
		if(targ->Left) n_ch += left ;
		if(targ->Right)n_ch += right ;
		
		switch(n_ch){
			case none:{
				delete targ ;
				*targp = 0 ;
				break ;
			}
			case left:{
				*targp = targ->Left ;
				targ->Left = 0 ;
				delete targ ;
				break ;
				
			}
			case right:{
				*targp = targ->Right ;
				targ->Right = 0 ;
				delete targ ;
				break ;
			}
			case both:{
				tmp = RemoveLeftMostFromRight(targ) ;				
				delete targ->Usr ;
				targ->Usr = tmp->Usr ;
				tmp->Usr = 0 ;
				break ; 
			}
			default:{	
				cerr << "Corrupt tree in Remove() !!\n" ;
			}
		}
		TopNode = ParentOfTop.Right   ;
	}
}
	
		
void BSTree::Print(ostream &out){ 

	Print(out, TopNode, 0) ; 
} ;
   
 
NodeUsrDat *BSTree::Search(const char *key, Node *here){
		
  int cmp ;
	
	if(here == 0)
		return(0) ;
	else{ 
		cmp = here->Usr->Compare(key) ;
		if(cmp > 0) return(Search(key, here->Right)) ; 
  		if(cmp < 0) return(Search(key, here->Left)) ;
		return(here->Usr) ;
	}	
} ; 
	
	
	
void BSTree::Add(NodeUsrDat *dat, Node *here){
	
	if(here->Usr->Compare(dat->GetKey()) > 0){
		if(here->Right == 0)
			here->Right = new Node(dat)  ;
		else
			Add(dat, here->Right) ;
	}
	else{
		if(here->Left == 0) 
			here->Left = new Node(dat)  ;
		else
			Add(dat, here->Left) ;
	}
} ;

				
void BSTree::Print(ostream &out, Node *here, int recdepth){
	  
  int n ;
	if(here != 0 ){
		recdepth++ ;
		Print(out, here->Left, recdepth) ;
		for(n = 0 ; n < recdepth-1 ; n++) out << "\t" ; 
		here->Usr->Print(out) ;
		Print(out, here->Right, recdepth) ;
		
		
	}
	else
		out << "\n" ;
} ;
