

"""

ScrumPy -- Metabolic Modelling with Python

Copyright Mark Poolman 1995 - 2005

 This file is part of ScrumPy.

    ScrumPy is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    ScrumPy is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ScrumPy; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""

import sys
import Tkinter

UIType = "Tkinter"

#TODO need a plain text "gui" for API compatibility in batch mode

import Pmw

from Plotter import Plotter
from EdWin import EdWin

root = None
# root is declared here so that it can be seen in the
# implementations of the following functions.
# the software calling these functions should ensure
# that it is initialised, by calling init




def init(Root):
    global root
    root = Pmw.initialise(Root)



flist =None
PyShell = None

def init4idle(pysh):
    print "init4idle"
    global PyShell, flist
    PyShell = pysh
    init(PyShell.root)
    flist = PyShell.flist






############################## messages,
# all we do is make sure that messages.*
# get the right root

import Messages
def ErrorMsg(Message="", **kwargs):
    Messages.ErrorMsg(Parent=root,Message=Message, **kwargs)

def WarnMsg(Message = "",Parent=None, **kwargs):
    Messages.WarnMsg(Parent=root,Message=Message,**kwargs)

def InfoMsg(Message = "",**kwargs):
    Messages.InfoMsg(Parent=root,Message=Message,**kwargs)



################################ file dialogs, as messages

import FileDialogs

def LoadFile():
    return FileDialogs.LoadFile(Parent=root)

def LoadFileName():
    return FileDialogs.LoadFileName(Parent=root)

def SaveFile():
    return FileDialogs.SaveFile(Parent=root)

def SaveFileName():
    return FileDialogs.SaveFileName(Parent=root)



##############################################

def SimpleMtxView(mtx): # API compatibility with wx gui

    print mtx




