"""


ScrumPy -- Metabolic Modelling with Python

Copyright Mark Poolman 1995 - 2002

 This file is part of ScrumPy.

    ScrumPy is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    ScrumPy is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ScrumPy; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""

print "import edwin"""
import wx
from wx.py.editor import EditorNotebookFrame, EditorNotebook,  Buffer,  Editor
from wx.py import crust


import gui, Messages

ID_COMPILE = wx.NewId()



class ScrumPyEditFrame(EditorNotebookFrame):


   def __ScrumPyMenu(self):

       menu = wx.Menu()
       #compile = wx.MenuItem(menu, ID_COMPILE, "Compile",  "Save and compile this model")
       menu.Append(ID_COMPILE, "Compile")# TODO: get help strings working HelpString="Save and compile this model"
       self.Bind(wx.EVT_MENU, self.OnCompile, id=ID_COMPILE)

       return menu





   def __NewMenus(self):


        mb = self.MenuBar
        mb.Remove(3)  # Thr "Options" menu
        #mb.Remove(0)  # The "File" menu
        mb.Append(self.__ScrumPyMenu(), title="ScrumPy")

   def OnCompile(self,  event):
       #Messages.InfoMsg("Compile")
       self.Model.Reload()





   def _setup(self):
        """Setup prior to first buffer creation.

        Called automatically by base class during init."""
        self.notebook = EditorNotebook(parent=self)
        intro = 'ScrumPy - Editor  Metabolic Modelling in Python'
        import imp
        module = imp.new_module('__main__')
        import __builtin__
        module.__dict__['__builtins__'] = __builtin__
        namespace = module.__dict__.copy()
        self.crust = crust.Crust(parent=self.notebook, intro=intro, locals=namespace)
        #self.shell = self.crust.shell
        # Override the filling so that status messages go to the status bar.
        self.crust.filling.tree.setStatusText = self.SetStatusText
        # Override the shell so that status messages go to the status bar.
        #self.shell.setStatusText = self.SetStatusText
        # Fix a problem with the sash shrinking to nothing.
        #self.crust.filling.SetSashPosition(200)
        #self.notebook.AddPage(page=self.crust, text='*Shell*', select=True)
        self.setEditor(self.crust.editor)
        self.crust.editor.SetFocus()
        self.__NewMenus()

   def bufferCreate(self, filename=None):
        """Create new buffer."""
        buffer = Buffer()
        panel = wx.Panel(parent=self.notebook, id=-1)
        panel.filename = filename
        panel.Bind(wx.EVT_ERASE_BACKGROUND, lambda x: x)
        editor = Editor(parent=panel)
        panel.editor = editor
        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(editor.window, 1, wx.EXPAND)
        panel.SetSizer(sizer)
        panel.SetAutoLayout(True)
        sizer.Layout()
        buffer.addEditor(editor)
        buffer.open(filename)
        self.setEditor(editor)
        self.notebook.AddPage(page=panel, text=self.buffer.name, select=True)
        self.editor.setFocus()


   def bufferDestroy(self, name=None, *args, **kwargs):
       """name = None => Destroy the current buffer
           else destroy buffer associated with name """


       if name == None:
           EditorNotebookFrame.bufferDestroy(self)
       else:
           nb = self.notebook
           selection= -1
           for n in range(nb.GetPageCount()):
              p = nb.GetPage(n)
              print p.filename
              if p.filename == name:
                   selection = n

           if selection != -1:
               if selection == nb.GetSelection():
                   del self.buffers[self.buffer.id]
                   self.buffer = None  # Do this before DeletePage().

               nb.DeletePage(selection)



"""
e = m.EdWin
ed =e.buffers[3].editor
ed.window.GotoLine(10)
ed.window.SetCaretLineVisible(4)
"""
class EdWin(ScrumPyEditFrame):


    def __init__(self, Model=None,  Root=None, *args, **argsl):
        self.Model = Model
        Title = "ScrumPy - editing "
        if Model != None:
            Title += Model.ModelName
        ScrumPyEditFrame.__init__(self,parent=Root, title=Title)

        self.buf2file = {}
        self.file2buf = {}
        del self.buffers[self.buffers.keys()[0]]
        self.Show()

    def OpenFile(self, fname):   # just translate to local idiom  (for now)

        if self.file2buf.has_key(fname):
            Messages.InfoMsg(fname + " already open.")
        else:
            self.bufferCreate(fname)
            for k in self.buffers.keys():
                if not self.buf2file.has_key(k):
                    self.buf2file[k] = fname
                    self.file2buf[fname] = k


    def CloseFile(self,  fname=None):

        if fname == None:
             for fname in self.file2buf.keys()[:]:
                 self.CloseFile(fname)
        else:

            if not self.file2buf.has_key(fname):
                Messages.ErrorMsg("Can't close " + fname + " (not open)")
            else:
                buf = self.file2buf[fname]
                del self.buf2file[buf],  self.file2buf[fname]
                self.bufferDestroy(fname)


    def SaveFile(self, fname=None):
         if fname == None:
             for fname in self.file2buf.keys():
                 self.SaveFile(fname)
         else:
             if not self.file2buf.has_key(fname):
                 Messages.ErrorMsg("Can't save " + fname + " (not open)")
             else:
                 bid = self.file2buf[fname]
                 self.buffers[bid].save()


    def wakeup(self):
        pass
        # compatibility w/ idle edit windows,
        # TODO: raise when hidden etc.



def Test():
    e = EdWin()
    e.OpenFile("Foo")
    e.OpenFile("Bar")
    return e


#$ event <<compile>>
#$ win <Alt-c>
#$ unix <Alt-c>


class EdWinOld():#EditorWindow.EditorWindow):
        def __init__(self, Model=None, Root=None, *args, **argsl):

            EditorWindow.EditorWindow.__init__(self,
                                                 PyShell.flist,
                                                 Model.FileName,
                                                 None,
                                                 PyShell.root)
            self.model = Model
            self.guiroot = Root
            self.MakeMenu()
            self.text.bind("<<compile>>",self.MenuCompile)


        def CheckUsable(self):
            if self.model.Usable():
                return 1

            msg = "Model " + self.model.ModelName +" is not usable\n"
            msg += "try Menu/ScrumPy/Compile first"
            Messages.ErrorMsg(Parent=self.guiroot, Message=msg)
            return 0


        def SaveFile(self):
            self.menubar.children["file"].invoke(8)

        def MenuCompile(self):

            self.model.Reload()

        def MenuSaveSBML(self):
            fname = FileDialogs.SaveFileName()
            self.model.SaveSBML(fname)


        def MenuSimulate(self):

            if self.CheckUsable():
                SimDatReq.SimRequest(
                    None, #self,#NewWin(self.guiroot),
                    self.model,
                    self.model.NSteps,
                    self.model.GetTincr())


        def MenuSolve(self):
            if self.CheckUsable():
                self.model.FindSS()
                if self.model.IsOK():
                    Messages.InfoMsg(Message="Got steady-state")
                else:
                    Messages.ErrorMsg(Message="Failed to get steady-state\n"+
                                      self.model.ErrorMsg())

        def MenuInspector(self):
            if self.CheckUsable():
                self.model.AddStatMonitor(
                    Inspector.Inspector(self.model,self.model.ModelName))

        def MenuDynMonitor(self):
            if self.CheckUsable():
                self.model.AddDynMonitor(
                    Plotter.Plotter(Model=self.model,
                                    Root=self.guiroot,
                                    xname="Time",
                                    Title=self.model.ModelName))

        def MenuSaver(self):
            if self.CheckUsable():
                Saver.Saver(self.model)




        def MakeMenu(self):

            Menu = Tkinter.Menu(PyShell.root)
            Menu.add("command",{"label":"Compile", "command":self.MenuCompile})
            Menu.add("command",{"label":"Save SBML", "command": self.MenuSaveSBML})
            Menu.add("command",{"label":"Simulate", "command":self.MenuSimulate})
            Menu.add("command",{"label":"Solve", "command":self.MenuSolve})
            Menu.add("command",{"label":"Inspector", "command":self.MenuInspector})
            Menu.add("command",{"label":"Dynamic Monitor", "command":self.MenuDynMonitor})
            Menu.add("command",{"label":"Saver", "command":self.MenuSaver})
            self.menubar.add("cascade",{"label":"ScrumPy","menu":Menu})


print "import edwin end"""
