#!/usr/bin/python
"""
ScrumPy - Metabolic Modelling in Python
Graphical Python shell.
"""



__author__ = "Mark Poolman mgpoolman@brookes.ac.uk"
# Trivial modifcations to the wx "PyAlaMode" module by Patrick K. O'Brien <pobrien@orbtech.com>

__cvsid__ = "$ $" # todo
__revision__ = "$  $"# todo

import wx
from wx import py

import os
import sys
import platform

StartCode="""
import os,sys,platform
PyVer = platform.python_version().rsplit(".",1)[0]
sp = "/usr/lib/python"+PyVer+"/site-packages"
if sp not in sys.path:
    sys.path.append(sp)

print "StartCode import ScrumPy"
import ScrumPy, wxGUI
ScrumPy.Init(wxGUI)
print ScrumPy.gui
"""

from wx.py.editor import EditorNotebookFrame, EditorNotebook
from wx.py import crust




class ScrumPyEditFrame(EditorNotebookFrame):


   def _setup(self):
        """Setup prior to first buffer creation.

        Called automatically by base class during init."""
        self.notebook = EditorNotebook(parent=self)
        intro = 'ScrumPy - Editor  Metabolic Modelling in Python'
        import imp
        module = imp.new_module('__main__')
        import __builtin__
        module.__dict__['__builtins__'] = __builtin__
        exec(StartCode)
        module.__dict__['ScrumPy'] = ScrumPy
        namespace = module.__dict__.copy()
        self.crust = crust.Crust(parent=self.notebook, intro=intro, locals=namespace)
        #self.shell = self.crust.shell
        # Override the filling so that status messages go to the status bar.
        self.crust.filling.tree.setStatusText = self.SetStatusText
        # Override the shell so that status messages go to the status bar.
        #self.shell.setStatusText = self.SetStatusText
        # Fix a problem with the sash shrinking to nothing.
        #self.crust.filling.SetSashPosition(200)
        #self.notebook.AddPage(page=self.crust, text='*Shell*', select=True)
        self.setEditor(self.crust.editor)
        self.crust.editor.SetFocus()



class ScrumPyFrame(EditorNotebookFrame):


   def _setup(self):
        """Setup prior to first buffer creation.

        Called automatically by base class during init."""
        self.notebook = EditorNotebook(parent=self)
        intro = 'ScrumPy - Metabolic Modelling in Python'
        import imp
        module = imp.new_module('__main__')
        import __builtin__
        module.__dict__['__builtins__'] = __builtin__
        exec(StartCode)
        module.__dict__['ScrumPy'] = ScrumPy
        namespace = module.__dict__.copy()
        self.crust = crust.Crust(parent=self.notebook, intro=intro, locals=namespace)
        self.shell = self.crust.shell
        # Override the filling so that status messages go to the status bar.
        self.crust.filling.tree.setStatusText = self.SetStatusText
        # Override the shell so that status messages go to the status bar.
        self.shell.setStatusText = self.SetStatusText
        # Fix a problem with the sash shrinking to nothing.
        self.crust.filling.SetSashPosition(200)
        self.notebook.AddPage(page=self.crust, text='ScrumPy', select=True)
        self.setEditor(self.crust.editor)
        self.crust.editor.SetFocus()

class App(wx.App):
    """ScrumPy graphical shell"""

    def __init__(self, filename=None):
        print "app.__init__ "
        self.filename = filename
        wx.App.__init__(self, redirect=False)

    def OnInit(self):
        print "app.OnInit"
        wx.InitAllImageHandlers()
        self.frame = ScrumPyFrame(filename=self.filename,title="ScrumPy - Metabolic Modelling in Python")
        self.frame.Show()
        self.SetTopWindow(self.frame)
        exec(StartCode)
        ScrumPy.gui.root = self.frame
        print "End OnInit",  ScrumPy.gui.__file__

        return True




def main(filename=None):
    #del sys.argv[1]
    if not filename and len(sys.argv) > 1:
        filename = sys.argv[1]
    if filename:
        filename = os.path.realpath(filename)
    print "start main"
    app = App(filename)

    app.MainLoop()

if __name__ == '__main__':
    main()
